/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.spa.commons.utils.StringUtils
 */
package com.deepexi.scd.calculate.util;

import com.deepexi.spa.commons.utils.StringUtils;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;

public class DataCollectors {
    public static <T, K> Map<K, List<T>> groupingBy(List<T> list, Function<T, K> groupingBy) {
        return list.stream().collect(Collectors.groupingBy(groupingBy));
    }

    public static <T> Collection<List<T>> groupingBy(List<T> list, int size) {
        return list.stream().collect(Collectors.groupingBy(g -> list.indexOf(g) / size)).values();
    }

    public static <T> List<T> getDistinctList(List<T> list, Function<T, ?> keyExtractor) {
        return list.stream().filter(DataCollectors.distinctByKey(keyExtractor)).collect(Collectors.toList());
    }

    public static <T, U extends Comparable<? super U>> List<T> getDistinctList(List<T> list, Function<T, ?> keyExtractor, Function<T, U> sortedMapper) {
        return list.stream().filter(DataCollectors.distinctByKey(keyExtractor)).collect(Collectors.toList()).stream().sorted(Comparator.comparing(sortedMapper)).collect(Collectors.toList());
    }

    public static <T> BigDecimal getSum(List<T> list, Function<T, BigDecimal> sumMapper) {
        return list.stream().map(sumMapper).reduce(BigDecimal.ZERO, BigDecimal::add);
    }

    public static <T, R> Map<R, BigDecimal> getSum(List<T> list, Function<T, R> groupingBy, Function<T, BigDecimal> sumMapper) {
        return list.stream().collect(Collectors.groupingBy(groupingBy, Collectors.reducing(BigDecimal.ZERO, sumMapper, BigDecimal::add)));
    }

    public static <T> String joinKey(T ... elements) {
        return StringUtils.join((Object[])elements, (String)"-");
    }

    private static <T> Predicate<T> distinctByKey(Function<? super T, ?> keyExtractor) {
        ConcurrentHashMap seen = new ConcurrentHashMap();
        return t -> seen.putIfAbsent(keyExtractor.apply(t), Boolean.TRUE) == null;
    }

    public static <K, V extends Comparable<? super V>> LinkedHashMap<K, V> sortByValue(Map<K, V> map, int flag) {
        LinkedHashMap sortMap = new LinkedHashMap();
        if (flag == 1) {
            map.entrySet().stream().sorted(Comparator.comparing(Map.Entry::getValue)).forEach(entry -> {
                Comparable cfr_ignored_0 = (Comparable)sortMap.put(entry.getKey(), entry.getValue());
            });
        } else {
            map.entrySet().stream().sorted((o1, o2) -> ((Comparable)o2.getValue()).compareTo(o1.getValue())).forEach(entry -> {
                Comparable cfr_ignored_0 = (Comparable)sortMap.put(entry.getKey(), entry.getValue());
            });
        }
        return sortMap;
    }

    public static <K, V extends Comparable<? super V>> LinkedHashMap<K, V> takeMap(LinkedHashMap<K, V> map, int length) {
        ArrayList<Map.Entry<K, V>> lists = new ArrayList<Map.Entry<K, V>>(map.entrySet());
        LinkedHashMap sortedMap = new LinkedHashMap();
        if (lists.size() >= length) {
            for (Map.Entry entry : lists.subList(0, length)) {
                sortedMap.put(entry.getKey(), entry.getValue());
            }
        } else {
            for (Map.Entry entry : lists) {
                sortedMap.put(entry.getKey(), entry.getValue());
            }
        }
        return sortedMap;
    }
}

